package org.dromara.knowledge.service;

import com.baomidou.mybatisplus.extension.service.IService;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.knowledge.domain.KnowledgeFragment;
import org.dromara.knowledge.domain.bo.KnowledgeFragmentBo;
import org.dromara.knowledge.domain.vo.KnowledgeFragmentVo;

import java.util.Collection;
import java.util.List;

/**
 * 知识库片段Service接口
 *
 * @author pengles
 */
public interface KnowledgeFragmentService extends IService<KnowledgeFragment> {

    /**
     * 查询知识库片段
     */
    KnowledgeFragmentVo queryById(Long id);

    /**
     * 查询知识库片段列表
     */
    TableDataInfo<KnowledgeFragmentVo> queryPageList(KnowledgeFragmentBo bo, PageQuery pageQuery);

    /**
     * 查询知识库片段列表
     */
    List<KnowledgeFragmentVo> queryList(KnowledgeFragmentBo bo);

    /**
     * 新增知识库片段
     */
    Boolean insertByBo(KnowledgeFragmentBo bo);

    /**
     * 修改知识库片段
     */
    Boolean updateByBo(KnowledgeFragmentBo bo);

    /**
     * 校验并批量删除知识库片段
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 根据知识库ID查询片段列表
     */
    List<KnowledgeFragmentVo> queryListByKnowledgeId(Long knowledgeId);

    /**
     * 根据文档ID查询片段列表
     */
    List<KnowledgeFragmentVo> queryListByDocId(String docId);

    /**
     * 根据片段ID查询片段信息
     */
    KnowledgeFragmentVo queryByFid(String fid);
}